<?php

class Common
{
    private $BP;
    private $dpuID;

    function __construct($BPin){
        $this->BP = $BPin;
        $this->dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $this->BP->get_local_system_id();
    }
    
    /*
     * This function returns true if the user wiahes to use the new appliance's storage and false
     * to use the previous appliance's storage.
     */
    public function getbReplace(){
        $bReplace = true;
        
        echo "\n" .
            "Would you like to use the storage configuration of the new or the original\n" .
            "appliance? Enter 'Y' to use the new configuration or 'N' to use the \n" .
            "configuration on the original appliance.\n";
        $response = readline("(y/n): ");
        
        $valid = false;
        while (!$valid) {
            if ($response == "Y" || $response == "y") {
                $bReplace = true;
                $valid = true;
            } else if ($response == "N" || $response == "n"){
                $bReplace = false;
                $valid = true;
            } else {
                $response = readline("(y/n): ");
            }
        }
        return $bReplace;
    }
    
    /*
     * Creates a warning string for metadata restore, tuned slightly if hot vs cold recovery.
     */
    public function getMetadataWarning($restoreType) {
        $warning = "\nThe next step is to restore the metadata";
        
        if ($restoreType == 'cold') {
            $warning .= ", then select assets to recover from the backup copy media.\n";
        } else {
            $warning .= ", then go back to the target and select assets to recover.\n";
        }
        
        $warning .= "\n" .
                    "CAUTION:  Restoring metadata will overwrite this appliance's database and hosts file, \n" .
                    "          and all existing backups will be deleted.\n" .
                    "\n";
        
        return $warning;
    }
}
?>