<?php
// defines BP, xml, action, cookie


class Hosts {

    private $dpuID;
    private $localID;

    private $hostOldName;
    private $hostInfo;
    private $oldName;

    private $bValid;


    function __construct($BP, $sysID = NULL){
        // set hostInfo Old name and Info to empty array.
        $this->hostOldName = array();
        $this->hostInfo = array();
        $this->oldName = "";

        $this->dpuID = isset($sysID) ? $sysID : $BP->get_local_system_id();
        $this->localID = $BP->get_local_system_id();
    }


    function hostList($BP){
        $this->bValid = true;
        $hosts = $BP->get_host_list($this->dpuID);
        $returner = array();
        if ($hosts === false) {
            $this->bValid = false;
        } else {
            foreach ($hosts as $name) {
                $entry = array();
                $hostInfo = $BP->get_host_info($name, $this->dpuID);
                if ($hostInfo === false) {
                    $this->bValid = false;
                    break;
                } else {
                    $entry['Name'] = $hostInfo['name'];
                    if (array_key_exists('ip', $hostInfo))
                        $entry['IP'] = $hostInfo['ip'];
                    if (array_key_exists('long_name', $hostInfo))
                        $entry['Longname'] = $hostInfo['long_name'];
                    if (array_key_exists('aliases', $hostInfo)) {
                        foreach ($hostInfo['aliases'] as $alias) {
                            $entry['Alias'] = $alias;
                        }
                    }
                    $returner[] = $entry;
                }
            }
        }
        if (!$this->bValid) {
            return false;
        } else {
            return $returner;
        }
    }

    function addHost($BP, $name, $ip, $aliases = NULL){
        // disclaimer
        echo "\nAdding a host entry for the new appliance, which is the target for recovery.\n" .
            "For overall host file management, open a web browser to do so through the UI.\n";

        $hostInfo = array ("name" => $name, "ip" => $ip);

        /*
        if (isset($aliases)) {
            $aliasNames = buildAliases($aliases);
            $hostInfo['aliases'] = $aliasNames;
        }
        */

        if ($this->bValid) {
            //$BP->buildResult($xml, $BP->save_host_info($hostInfo, $dpuID));
            $result = $BP->save_host_info($hostInfo, $this->dpuID);
            $bpError = $BP->getError();
            // See if already present.  If so, okay.
            if ($result === false) {
                $info = $BP->get_host_info($hostInfo['name'], $this->dpuID);
                if ($info !== false && $info['ip'] == $hostInfo['ip']) {
                    return true;
                } else {
                    // The error is on the save.
                    echo "Error on save: $bpError\n";
                }
            } else {
                return true;
            }
        } else {
            return false;
        }
    }


    function hostIP($entry, $BP){
        $hostInfo = $BP->get_host_info(strtolower($entry), $this->dpuID);

    }

    function buildAliases($aliasString)
    {
        $aliasNames = array();

        // aliases string will be in the form <alias>,<alias>, ...

        $aliasString = trim($aliasString, ",");

        $aliasExploded = explode(",", $aliasString);
        $i = 0;
        foreach ($aliasExploded as $aliasName) {
            $aliasNames[$i++] = $aliasName;
        }

        return $aliasNames;
    }


}