<?php

class Metadata
{

    private $BP;
    private $metadataID;
    private $bReplace;
    private $dpuID;

    function __construct($BPin, $metaIDin, $bRepIn, $dpuIn)
    {
        $this->BP = $BPin;
        $this->metadataID = $metaIDin;
        $this->bReplace = $bRepIn;
        $this->dpuID = $dpuIn;


    }

    function check_and_restore()
    {
        $ret = $this->metadata_check();
        if ($ret !== false){
            echo "\nAppliance metadata check completed\n";
            $ret = $this->metadata_restore();
            if ($ret !== false){
                echo "\nMetadata restore completed\n";
                return true;
            } else {
                echo "\nMetadata restore failed \n";
                return false;
            }
        }

    }

    function metadata_check()
    {
        $backupID = $this->metadataID;
        $bReplace = $this->bReplace;
        $action = 'check';

        $filter = array('backup_id' => $backupID,
            'save_new_storage' => $bReplace,
            'action' => $action);

        $result = $this->BP->restore_appliance_metadata($filter);

        if ($result !== false) {
            //for 7.0 - empty array.  We may need these notices one day, but not today.
            if (!empty($result)) {
                global $Log;
                foreach ($result as $msg) {
                    $Log->writeVariable($msg);
                    //$BP->setWarning($xml, $msg);
                }
                $result = array();
            }
            return true;
        } else {
            $myErr = $this->BP->getError();
            echo "$myErr";
            return false;
        }
    }

    function metadata_restore()
    {
        $backupID = $this->metadataID;
        $bReplace = $this->bReplace;
        $action = 'restore';

        $filter = array('backup_id' => $backupID,
            'save_new_storage' => $bReplace,
            'action' => $action);

        $line = readline("Final check: continue with the metadata restore? (y/n): ");
        if ($line !== "y" && $line !== "Y"){
            return false;
        } else {
            echo "Restoring appliance metadata...\n";
        }

        //we have to cancel any running jobs before restoring system metadata
        $jobList = $this->BP->get_job_list($this->dpuID);

        if ($jobList !== false) {
            foreach ($jobList as $id => $backup) {
                $this->BP->cancel_job($id);
            }
        }


        $result = $this->BP->restore_appliance_metadata($filter);
        if ($result !== false) {
            return true;
        } else {
            $myErr = $this->BP->getError();
            echo "$myErr";
            return false;
        }
    }

}
?>