<?php

//grand client list is indexed by g-client id.  We need client id (not g-client id) to pass to bp_get_all_last_backups
//
function buildClientList($BP, $names, $sourceID) {
    $clientList = array();
    $i = 0;
    foreach ($names as $client) {
        $cid = $BP->get_client_id($client, $sourceID);
        $clientList[$i++] = $cid;
    }
    return $clientList;
}

function buildClientListForBackups($BP, $names, $sourceID) {
    $dpuID = $BP->get_local_system_id();
    global $Log;
    $grandClients = $BP->get_grandclient_list($sourceID);
    $clientNameList = array();
    $clientList = array();

    $clientValues = $names;
    $i = 0;
    foreach ($clientValues as $clientValue) {
        $clientNameList[$i++] = $clientValue;
    }
    $selectGClients = array_intersect($grandClients,$clientNameList);

    $i=0;
    foreach ( $selectGClients as $id => $name) {
        $clientList[$i++] = $id;
    }

    return $clientList;
}

// get latest metadata backup by ID
function getMetadataBackup($BP, $cids, $dpuID) {
    global $Log;

    $metadataID = "60";
    $metadataBackup = NULL;
    if(is_array($cids)) {
        $result = $BP->get_all_last_backups($cids, $dpuID);
        $Log->writeVariable("all last");
        $Log->writeVariable($result);
        if($result == false) {
            $msg = $BP->getError();
            global $Log;
            $Log->writeVariable($msg);
        }
        if($result != false) {
            foreach ( $result as $lastbackups ) {
                if(array_key_exists('groups', $lastbackups)) {
                    $backupGroups[] = $lastbackups['groups'];
                    foreach ($backupGroups as $groups){
                        foreach($groups as $backups){
                            if(array_key_exists('app_id', $backups) && $backups['app_id'] == $metadataID) {
                                if (array_key_exists('backup_ids', $backups)) {
                                    foreach ($backups as $ids) {
                                        $metadataBackup = $ids[0];
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    if (isset($metadataBackup)){
        return $metadataBackup;
    } else {
        return false;
    }
}

function getClientBackups($BP, $cids, $dpuID, $appID, $match, $onlyOne) {
    $clientBackupIDs = array();
    if (is_array($cids)) {
        $result = $BP->get_all_last_backups($cids, $dpuID);
        global $last;
        // $result = $last;
        if($result == false) {
            $msg = $BP->getError();
            global $Log;
            $Log->writeVariable($msg);
        }
        if ($result != false) {
            foreach ($result as $lastBackups) {
                if (isset($lastBackups['groups'])) {
                    $groups = $lastBackups['groups'];
                    foreach ($groups as $group) {
                        if (isset($group['app_id'])) {
                            $thisApp = $group['app_id'];
                        }
                        if ($match) {
                            if ($thisApp !== $appID) {
                                continue;
                            }
                        } else {
                            if ($thisApp === $appID) {
                                continue;
                            }
                        }
                        if (isset($group['backup_ids'])) {
                            $bids = $group['backup_ids'];
                            foreach ($bids as $id){
                                $clientBackupIDs[] = $id;
                                if ($onlyOne) {
                                    break;
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    return $clientBackupIDs;
}

?>