#!/usr/bin/php
<?php

// This is a php CLI script, so it can be run from the commandline like this:
//    ./send_notification.php [options...]
// (i.e., you don't run it like this: "php -f send_notification.php [options...]")
// It has a usage message to tell you what should be on the commandline.

// main program starts here
if($argc < 3) {
	echo "Usage: ".basename($argv[0])." <notification_id> <target> [str1 str2 ... str5]\n";
	echo "  notification ID and target are mandatory\n";
	echo "  remaining optional items are args for format string in DB\n";
	die;
}
else {
	$id = (int)$argv[1];
	$target = $argv[2];
}

$testname = 'Do bp_send_notification';
print "Notification ID is " .$id. "\n";
print "Target is " .$target. "\n";
print "Argument count: " .$argc. "\n";

bp_bypass_cookie(3);
echo "\nCalling bp_send_notification\n";


switch ($argc) {
	case 3:
		$ret = bp_send_notification($id, $target);
		break;
	case 4:
		$ret = bp_send_notification($id, $target, $argv[3]);
		break;
	case 5:
		$ret = bp_send_notification($id, $target, $argv[3], $argv[4]);
		break;
	case 6:
		$ret = bp_send_notification($id, $target, $argv[3], $argv[4], $argv[5]);
		break;
	case 7:
		$ret = bp_send_notification($id, $target, $argv[3], $argv[4], $argv[5],
			$argv[6]);
		break;
	case 8:
		$ret = bp_send_notification($id, $target, $argv[3], $argv[4], $argv[5],
			$argv[6], $argv[7]);
		break;
	case 9:
		// this is an error case
		$ret = bp_send_notification($id, $target, $argv[3], $argv[4], $argv[5],
			$argv[6], $argv[7], $argv[9]);
		break;
	}

if ($ret === false || $ret === NULL) {
	echo "error is: ".bp_error()."\n";
	bp_destroy_cookie();
	exit("bp_send_notification returned FALSE\n");

} else {
	print "Success!\n";
}

bp_destroy_cookie();
print "Done with ".basename($argv[0])."\n";

?>
